<?php
/* $Id: ipAuthenticator.admin.inc,v 1.3 2008/04/29 19:16:03 jonfrancisskydiver Exp $ 
 * IP based authenticator
 * @author C/S Group - Jonathan T. Francis
 *
*/
drupal_add_css(drupal_get_path("module","ipAuthenticator")."/css/ipAuthenticator.admin.css","module", "all", FALSE);
drupal_add_js( drupal_get_path("module","ipAuthenticator")."/js/ipAuthenticator.admin.js");


/**
 * administer the ipAuthenticator parameters.
 */
function ipAuthenticator_admin($form_state) {
	global $user;
	
	$form['ip_list'] = array(
		'#type' => 'fieldset',
		'#title' => t('Current IP Authenticators')."<br/>",
		'#description' => t('Click on a link to modify the authenticator assignment'),
		'#collapsible' => FALSE,
		'#callapsed' => FALSE,
		'#weight' =>0		
	);	
	
	$roles = user_roles();
	$result = _get_ip_authenticators(null, "id, roles, ip1, ip2");
	$i=0;
	while($row = db_fetch_array($result)) {
		
		$row["ip1"] = long2ip($row["ip1"]); //this takes the mysql command, INET_NTOA out of the query string.
		
		if (0 == $row["ip2"]) 
			$row["ip2"] = "";
		 else 
			$row["ip2"] = long2ip($row["ip2"]);
		
		$ip2_text = ($row["ip2"]!="") ? " - ".$row["ip2"] : "";
		$title = $row['ip1'] . $ip2_text ." authenticates to: ".$roles[$row["roles"]];
		
		$form['ip_list'][$row["id"]] = array(
			'#prefix' => '<div>',
			'#suffix' => '</div>',
			'#value' => l($title,"admin/settings/ipAuthenticator/edit/".$row["id"])
		);
	}
	
	$form['ips'] = array(
		'#type' => 'fieldset',
		'#title' => t('IP address assignment')."<br/>",
		'#collapsible' => FALSE,
		'#callapsed' => FALSE,
		'#weight' =>0
	);
	
	$form['ips']['ip1'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'textfield',
		'#title' => 'IP 1',
		'#size' => '15',
		'#required' => TRUE,
		'#suffix' => '</div>'
	);
	$form['ips']['seperator'] = array (
		'#prefix' => '<div class="floatLeft" id="formSeperator">',
		'#value' => '&nbsp;&nbsp; - &nbsp;&nbsp;',
		'#suffix' => '</div>',		
	);
	$form['ips']['ip2'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'textfield',
		'#title' => 'IP 2',
		'#description' => 'Leave blank for<br/>individual IPs',
		'#size' => '15',
		'#suffix' => '</div>',
	);
	$form['ips']['seperator1'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#value' => '&nbsp; &nbsp; &nbsp; &nbsp;',
		'#suffix' => '</div>',		
	);	
	$form['ips']['role'] = array(
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'select',
		'#title' => t('Assign to Role'),
		'#options' => $roles,
		'#description' => "Select a role to assign the ips",
		'#suffix' => '</div>',
	);
	
	$form['#validate'][] = 'ipAuthenticator_validate';
	$form['#submit'][] = 'ipAuthenticator_submit';
	
	return system_settings_form($form);
}

function ipAuthenticator_validate($form, &$form_state) {

	if (!preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\$/x", $form_state['values']['ip1'])) {
		form_set_error('ip1', "You must enter an ip address in the first field.");
	}
	
	if ("" != trim($form_values['values']['ip2']) && !preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\$/x", trim($form_values['values']['ip2'])) ) {
		form_set_error('ip2', "You must enter a valid IP address in the second field, or leave the second field blank.");
	}
	
}

function ipAuthenticator_submit($form, &$form_values) {
	if (!preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\$/x", trim($form_values['values']['ip2'])) ) 
		$ip2 = trim($form_values["values"]["ip2"]);
	else
		$ip2 = ip2long(trim($form_values["values"]['ip2']));
		
	$sql = "INSERT INTO {ipAuthenticator} (ip1, ip2, roles) VALUES ('%s','%s','%s')";
	db_query($sql, ip2long(trim($form_values['values']['ip1'])), $ip2, $form_values['values']['role']);
	if (db_affected_rows() == 0) {
		echo mysql_error();
		exit;
	}
}

function _get_ip_role_info($id) {
	
	$result = db_query("SELECT roles, ip1, ip2 FROM {ipAuthenticator} WHERE id = '%s'", $id);
	$row = db_fetch_array($result);
	$row["ip1"] = long2ip($row["ip1"]);
	
	if ($row["ip2"] == 0) 
		$row["ip2"] = "";
	else 
		$row["ip2"] = long2ip($row["ip2"]);	

	return $row;	
}

function ipAuthenticator_admin_edit($arg, $arg1, $arg3) {
	
	if (!preg_match("/^[0-9]+\$/", $arg3)) {
		drupal_set_message("Please select your authenticator again");
		header("Location: /admin/settings/ipAuthenticator");
		exit;
	}
	
	$row = _get_ip_role_info($arg3);
	
	$form['ips'] = array(
		'#type' => 'fieldset',
		'#title' => t('IP address assignment'),
		'#collapsible' => FALSE,
		'#callapsed' => FALSE,
		'#weight' =>0
	);
	
	$form['ips']['ip1'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'textfield',
		'#title' => 'IP 1',
		'#size' => '15',
		'#default_value' => $row["ip1"],
		'#required' => TRUE,
		'#suffix' => '</div>'
	);
	$form['ips']['seperator'] = array (
		'#prefix' => '<div class="floatLeft" id="formSeperator">',
		'#value' => '&nbsp;&nbsp; - &nbsp;&nbsp;',
		'#suffix' => '</div>',		
	);
	$form['ips']['ip2'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'textfield',
		'#title' => 'IP 2',
		'#description' => 'Leave blank for<br/>individual IPs',
		'#size' => '15',
		'#default_value' => $row["ip2"],
		'#suffix' => '</div>',
	);
	$form['ips']['seperator1'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#value' => '&nbsp; &nbsp; &nbsp; &nbsp;',
		'#suffix' => '</div>',		
	);	
	$form['ips']['role'] = array(
		'#prefix' => '<div class="floatLeft">',
		'#type' => 'select',
		'#title' => t('Assign to Role'),
		'#options' => user_roles(),
		'#default_value' => $row["roles"],
		'#description' => "Select a role to assign the ips",
		'#suffix' => '</div>',
	);
	$form['ips']['delete'] = array(
		'#prefix' => '<div class="floatLeft" id="deleteLink">',
		'#value' => '&nbsp; &nbsp; &nbsp; &nbsp;'.l("delete", "admin/settings/ipAuthenticator/delete/".$arg3),
		'#suffix' => '</div>',
	);
	$form['id'] = array(
		'#type' => 'hidden',
		'#value' => $arg3		
	);
	$form['#validate'][] = 'ipAuthenticator_validate';
	$form['#submit'][] = 'ipAuthenticator_edit_submit';
	$form['#redirect'] = 'admin/settings/ipAuthenticator';
	
	return system_settings_form($form);	
}


function ipAuthenticator_edit_submit($form, &$form_values) {
	if (!preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\$/x", trim($form_values['values']['ip2'])) ) 
		$ip2_long = trim($form_values['values']['ip2']);
	else
		$ip2_long = trim(ip2long($form_values['values']['ip2']));
	
	$sql = "UPDATE {ipAuthenticator} SET ip1 = '%s', ip2 = '%s', roles = '%s' WHERE id = '%s'"; 	
	
	db_query($sql, ip2long(trim($form_values['values']['ip1'])), $ip2_long, $form_values['values']['role'], $form_values['values']['id']);
	if (db_affected_rows() == 0) {
		echo mysql_error();
		exit;
	}
}


function ipAuthenticator_admin_delete($arg, $arg1, $arg3) {	
	
	if (!preg_match("/^[0-9]+\$/", $arg3)) {
		drupal_set_message("Please select your authenticator again");
		header("Location: /admin/settings/ipAuthenticator");
		exit;
	}
	
	$row = _get_ip_role_info($arg3);
	$roles = user_roles();
	
	$ip2_text = ($row["ip2"]!="") ? " - ".$row["ip2"] : "";
	$title = "<li>".$row['ip1'] . $ip2_text ." authenticates to: ".$roles[$row["roles"]];

	$form["markup"] = array(
		'#prefix' => "<div id='confirmbox'>",
		'#suffix' => "",
		'#value' => "Are you certain that you wish to delete this ip authenticator? <ul>" . $title . "</ul>"		
	);
	
	$form["accept"] = array(
		'#type' => 'submit',
		'#value' => 'Delete',
		'#prefix' => '<div class="floatLeft">',
		'#suffix' => '</div>'
	);
	$form['seperator1'] = array (
		'#prefix' => '<div class="floatLeft">',
		'#value' => '&nbsp; &nbsp; &nbsp; &nbsp;',
		'#suffix' => '</div>',		
	);
	$form['cancel'] = array(
		'#prefix' => '<div class="floatLeft">',
		'#value' => '<input type="button" value="Cancel" id="cancel">',
		'#suffix' => '</div></div>'
	);
	$form['id'] = array(
		'#type' => 'hidden',
		'#value' => $arg3		
	);
	
	$form['#submit'][] = 'ipAuthenticator_admin_delete_submit';
	$form['#redirect'] = 'admin/settings/ipAuthenticator';
	$form['#validate'][] = 'ipAuthentiator_admin_delete_validate';
	return $form;
}

function ipAuthentiator_admin_delete_validate($form, &$form_values) {
	if (!preg_match("/^[0-9]+\$/", $form_values["values"]["id"]))
		form_set_error("id", "Please return to the ".l("admin/settings/ipAuthenticator", "ipAuthenticator"). " page and then navigate back here. A form value was lost.");
}

function ipAuthenticator_admin_delete_submit($form, &$form_values) {
	$result = db_query("DELETE FROM {ipAuthenticator} WHERE id = '%s'", $form_values['values']['id']);
	if (db_affected_rows() < 1) {
		drupal_set_message("Error in execution of sql statement -- no changes made.");
	}	else {
		drupal_set_message("The IP Authenticator item has been deleted.");
	}
}

?>